! Copyright (C) GemTalk Systems 1986-2021.  All Rights Reserved.
! Class Declarations
! Generated file, do not Edit

doit
(Array
	subclass: 'BlockSorter'
	instVarNames: #( sortBlock sortNodes )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'BlockSorter is a concrete class that along with the class SortBlockNode implements the 
 behavior used to sort collections efficiently. It is an interface to an algorithm based 
 on an efficient merge-sort.  

 To use BlockSorter explicitly outside of the indexing subsystem, 
 the recommended way is to send  sortWithBlock:  or  sortWithBlock:persistentRoot:
 to a kind of Collection .

Constraints:
	sortBlock: Object
	sortNodes: Array';
		immediateInvariant.
true.
%

removeallmethods BlockSorter
removeallclassmethods BlockSorter

doit
(Array
	subclass: 'BtreePlusNode'
	instVarNames: #( rootNode numElements )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusNode
removeallclassmethods BtreePlusNode

doit
(BtreePlusNode
	subclass: 'BtreePlusInteriorNode'
	instVarNames: #( lastValue lastRoot )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusInteriorNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusInteriorNode
removeallclassmethods BtreePlusInteriorNode

doit
(BtreePlusInteriorNode
	subclass: 'BtreePlusInteriorKeyValueNode'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusInteriorKeyValueNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusInteriorKeyValueNode
removeallclassmethods BtreePlusInteriorKeyValueNode

doit
(BtreePlusInteriorNode
	subclass: 'BtreePlusInteriorKeyValueRootObjectNode'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusInteriorKeyValueRootObjectNode is part of the Indexing and Querying subsystem. 
It implements GemStone internals and is not intended for customer use, by creating instances 
or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusInteriorKeyValueRootObjectNode
removeallclassmethods BtreePlusInteriorKeyValueRootObjectNode

doit
(BtreePlusNode
	subclass: 'BtreePlusLeafNode'
	instVarNames: #( previousLeaf nextLeaf )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusLeafNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusLeafNode
removeallclassmethods BtreePlusLeafNode

doit
(BtreePlusLeafNode
	subclass: 'BtreePlusLeafKeyNode'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusLeafKeyNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusLeafKeyNode
removeallclassmethods BtreePlusLeafKeyNode

doit
(BtreePlusLeafNode
	subclass: 'BtreePlusLeafKeyValueNode'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusLeafKeyValueNode is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusLeafKeyValueNode
removeallclassmethods BtreePlusLeafKeyValueNode

doit
(BtreePlusLeafNode
	subclass: 'BtreePlusLeafKeyValueRootObjectNode'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusLeafKeyValueRootObjectNode is part of the Indexing and Querying subsystem. 
It implements GemStone internals and is not intended for customer use, by creating instances 
or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusLeafKeyValueRootObjectNode
removeallclassmethods BtreePlusLeafKeyValueRootObjectNode

doit
(Array
	subclass: 'GsAbstractIndex'
	instVarNames: #( nscRoot btreeRoot options isComplete progress comparisonForSort )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'GsAbstractIndex is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsAbstractIndex
removeallclassmethods GsAbstractIndex

doit
(GsAbstractIndex
	subclass: 'GsIdentityIndex'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'GsIdentityIndex is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsIdentityIndex
removeallclassmethods GsIdentityIndex

doit
(GsAbstractIndex
	subclass: 'GsRangeEqualityIndex'
	instVarNames: #( lastElementClass optimizingComparison )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'GsRangeEqualityIndex is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsRangeEqualityIndex
removeallclassmethods GsRangeEqualityIndex

doit
(GsRangeEqualityIndex
	subclass: 'GsConstrainedCharacterCollectionIndex'
	instVarNames: #( collator constraintType )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'GsConstrainedCharacterCollectionIndex is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsConstrainedCharacterCollectionIndex
removeallclassmethods GsConstrainedCharacterCollectionIndex

doit
(GsConstrainedCharacterCollectionIndex
	subclass: 'GsUnicodeRangeEqualityIndex'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'GsUnicodeRangeEqualityIndex is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsUnicodeRangeEqualityIndex
removeallclassmethods GsUnicodeRangeEqualityIndex

doit
(Array
	subclass: 'GsPathTerm'
	instVarNames: #( name offset securityPolicies children updateBtree needsDepList requirePathTerms termsRequired nilOnPath )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsPathTerm is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsPathTerm
removeallclassmethods GsPathTerm

doit
(GsPathTerm
	subclass: 'GsCollectionBasedPathTerm'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsCollectionBasedPathTerm is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsCollectionBasedPathTerm
removeallclassmethods GsCollectionBasedPathTerm

doit
(GsCollectionBasedPathTerm
	subclass: 'GsEnumeratedPathTerm'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsEnumeratedPathTerm is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsEnumeratedPathTerm
removeallclassmethods GsEnumeratedPathTerm

doit
(GsCollectionBasedPathTerm
	subclass: 'GsSetValuedPathTerm'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsSetValuedPathTerm is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsSetValuedPathTerm
removeallclassmethods GsSetValuedPathTerm

doit
(GsPathTerm
	subclass: 'GsOptionalPathTerm'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsOptionalPathTerm is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsOptionalPathTerm
removeallclassmethods GsOptionalPathTerm

doit
(GsPathTerm
	subclass: 'GsSelectorPathTerm'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'GsSelectorPathTerm  is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsSelectorPathTerm
removeallclassmethods GsSelectorPathTerm

doit
(Array
	subclass: 'GsSingleRefPathResult'
	instVarNames: #( searchOop isDead )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsSingleRefPathResult is used to represent the results of a reference path scan.
It is a subclass of Array and contains the following instance variables:

searchOop - the object for which the reference path was found.

isDead - a Boolean indicating if the search object was found to be dead
(disconnected from the repository).

The first elment of a GsSingleRefPathResult will be the limit object at the top
of the reference path.  The last element will be searchOop.  The other elements
represent intermediate objects which are traversered to go from the limit object
to the search object.';
		immediateInvariant.
true.
%

removeallmethods GsSingleRefPathResult
removeallclassmethods GsSingleRefPathResult

doit
(Association
	subclass: 'GsAbstractReferenceAssociation'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The abstract class GsAbstractReferenceAssociation represents the value of an operand in a GsAbstractQueryPredicate.';
		immediateInvariant.
true.
%

removeallmethods GsAbstractReferenceAssociation
removeallclassmethods GsAbstractReferenceAssociation

doit
(GsAbstractReferenceAssociation
	subclass: 'GsConstantReferenceAssociation'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsConstantReferenceAssociation represents the value of a literal operand in a GsAbstractQueryPredicate.';
		immediateInvariant.
true.
%

removeallmethods GsConstantReferenceAssociation
removeallclassmethods GsConstantReferenceAssociation

doit
(GsAbstractReferenceAssociation
	subclass: 'GsQueryPathReferenceAssociation'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsQueryPathReferenceAssociation represents the value of a path operand in a GsAbstractQueryPredicate.';
		immediateInvariant.
true.
%

removeallmethods GsQueryPathReferenceAssociation
removeallclassmethods GsQueryPathReferenceAssociation

doit
(GsAbstractReferenceAssociation
	subclass: 'GsVariableReferenceAssociation'
	instVarNames: #( bound )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsVariableReferenceAssociation  represents the value of a variable operand a GsAbstractQueryPredicate.';
		immediateInvariant.
true.
%

removeallmethods GsVariableReferenceAssociation
removeallclassmethods GsVariableReferenceAssociation

doit
(GsVariableReferenceAssociation
	subclass: 'GsPathReferenceAssociation'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsPathReferenceAssociation  is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsPathReferenceAssociation
removeallclassmethods GsPathReferenceAssociation

doit
(BtreeComparisonForCompare
	subclass: 'BtreeComparisonForIdentity'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Comparison-Core';
		comment: 'BtreeComparisonForIdentity is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.

During btree sort and compare operations (for BtreeNode and subclasses) the exact method
send for doing comparison operations varies depending upon whether the comparison is for 
a sort or a query (compare). The class translates the message into a variant for sorting.';
		immediateInvariant.
true.
%

removeallmethods BtreeComparisonForIdentity
removeallclassmethods BtreeComparisonForIdentity

doit
(BtreeComparisonForSort
	subclass: 'BtreeOptimizedComparison'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Comparison-Core';
		comment: 'BtreeOptimizedComparison is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreeOptimizedComparison
removeallclassmethods BtreeOptimizedComparison

doit
(BtreeComparisonForSort
	subclass: 'BtreeOptimizedUnicodeComparison'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Comparison-Core';
		comment: 'BtreeOptimizedUnicodeComparison is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreeOptimizedUnicodeComparison
removeallclassmethods BtreeOptimizedUnicodeComparison

doit
(BtreeQuerySpec
	subclass: 'BtreePlusComparisonQuerySpec'
	instVarNames: #( key opCode selector optimizingComparison )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-QuerySpec-Core';
		comment: 'BtreePlusComparisonQuerySpec is an concrete class that implements behavior for handling the double
 dispatching of messages for adding objects from a btreePlusNode that satisfy a particular query
 based on a comparison of a single set of values.

 The implementation for this class and its concrete subclasses is tightly coupled to alogorithms
 implemented in primitives, so these classes should not be modified.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusComparisonQuerySpec
removeallclassmethods BtreePlusComparisonQuerySpec

doit
(BtreePlusComparisonQuerySpec
	subclass: 'BtreePlusRangeComparisonQuerySpec'
	instVarNames: #( key2 opCode2 selector2 )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-QuerySpec-Core';
		comment: 'BtreePlusRangeComparisonQuerySpec is an concrete class that implements behavior for handling the double
 dispatching of messages for adding objects from a btreePlusNode that satisfy a particular query
 based on comparisons between two values.

 The implementation for this class and its concrete subclasses is tightly coupled to alogorithms
 implemented in primitives, so these classes should not be modified.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusRangeComparisonQuerySpec
removeallclassmethods BtreePlusRangeComparisonQuerySpec

doit
(BtreePlusRangeComparisonQuerySpec
	subclass: 'BtreePlusUnicodeRangeComparisonQuerySpec'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-QuerySpec-Core';
		comment: 'BtreePlusUnicodeRangeComparisonQuerySpec is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusUnicodeRangeComparisonQuerySpec
removeallclassmethods BtreePlusUnicodeRangeComparisonQuerySpec

doit
(BtreePlusComparisonQuerySpec
	subclass: 'BtreePlusUnicodeComparisonQuerySpec'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-QuerySpec-Core';
		comment: 'BtreePlusUnicodeComparisonQuerySpec is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusUnicodeComparisonQuerySpec
removeallclassmethods BtreePlusUnicodeComparisonQuerySpec

doit
(CollectionBasedPathEvaluator
	subclass: 'EnumeratedPathEvaluator'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Evaluators';
		comment: 'EnumeratedPathEvaluator is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods EnumeratedPathEvaluator
removeallclassmethods EnumeratedPathEvaluator

doit
(EqualityIndexSpecification
	subclass: 'ConstrainedCharacterCollectionIndexSpecification'
	instVarNames: #( collator constraintType )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Index-Core';
		comment: 'ConstrainedCharacterCollectionIndexSpecification is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods ConstrainedCharacterCollectionIndexSpecification
removeallclassmethods ConstrainedCharacterCollectionIndexSpecification

doit
(EqualityIndexSpecification
	subclass: 'UnicodeIndexSpecification'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class UnicodeIndexSpecification provides details for specifying an index that contains 
Unicode Strings. Since it contains Unicode Strings, it requires a persistent IcuCollator instance 
associated with the index.';
		immediateInvariant.
true.
%

removeallmethods UnicodeIndexSpecification
removeallclassmethods UnicodeIndexSpecification

doit
(Error
	subclass: 'ExitClientError'
	instVarNames: #( status )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'ExitClientError is a subclass of Error, 
signalled when the application wants topaz (or other Gci client) to exit the
client process with a specified exit status.  Not a fatal error ;
client process should call GciLogout before exiting.';
		immediateInvariant.
true.
%

removeallmethods ExitClientError
removeallclassmethods ExitClientError

doit
(Error
	subclass: 'GsMalformedQueryExpressionError'
	instVarNames: #( errorCondition )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsMalformedQueryExpressionError is signaled when an attempt is made to execute a malformed GsQueryFormula.';
		immediateInvariant.
true.
%

removeallmethods GsMalformedQueryExpressionError
removeallclassmethods GsMalformedQueryExpressionError

doit
(Error
	subclass: 'GsQueryExpectedImplicitIdentityIndexError'
	instVarNames: #( gsQuery )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsQueryExpectedImplicitIdentityIndexError is part of the Indexing and Querying subsystem.  
It is used where an implicit identity index that was a side-effect of legacy indexing does
not exist, since btreeplus indexes do not have that side-effect';
		immediateInvariant.
true.
%

removeallmethods GsQueryExpectedImplicitIdentityIndexError
removeallclassmethods GsQueryExpectedImplicitIdentityIndexError

doit
(Error
	subclass: 'GsQueryParseError'
	instVarNames: #( position )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsQueryParseError is a subclass of Error, signalled when the parsing of a GsQuery finds incorrect syntax';
		immediateInvariant.
true.
%

removeallmethods GsQueryParseError
removeallclassmethods GsQueryParseError

doit
(IdentityKeyValueDictionary
	subclass: 'BtreePlusTraversalMapDictionary'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'BtreePlusTraversalMapDictionary is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.

Dictionary class for creating reverse lookup map for Btree Plus update operations.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusTraversalMapDictionary
removeallclassmethods BtreePlusTraversalMapDictionary

doit
(Notification
	subclass: 'GsUnsatisfiableQueryNotification'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsUnsatisfiableQueryNotification is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsUnsatisfiableQueryNotification
removeallclassmethods GsUnsatisfiableQueryNotification

doit
(Object
	subclass: 'AbstractReferencingObjectPolicy'
	instVarNames: #( manager )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Canonicalization';
		comment: 'AbstractReferencingObjectPolicy is part of the Canonical Object 
Framework.  This class is the abstract superclass for policy classes 
that are used to do the referencing object cleanup (i.e., replacing the 
duplicate object with the canonical object). Subclasses should implement 
#''canonicalizeReferencesIn:''. See ReferencingObjectPolicy for the
default implementation.';
		immediateInvariant.
true.
%

removeallmethods AbstractReferencingObjectPolicy
removeallclassmethods AbstractReferencingObjectPolicy

doit
(AbstractReferencingObjectPolicy
	subclass: 'ReferencingObjectPolicy'
	instVarNames: #( referencingClassHistories )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Canonicalization';
		comment: 'ReferencingObjectPolicy is part of the Canonical Object Framework.  
This class is the default policy used to do the referencing object cleanup.
In order to support manager cleanup, referencing (or container) classes must be 
specified to this policy using #''addRefencingClass:''.';
		immediateInvariant.
true.
%

removeallmethods ReferencingObjectPolicy
removeallclassmethods ReferencingObjectPolicy

doit
(Object
	subclass: 'BtreePlusNodeAuditor'
	instVarNames: #( auditResultString )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusNodeAuditor is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusNodeAuditor
removeallclassmethods BtreePlusNodeAuditor

doit
(Object
	indexableSubclass: 'BtreePlusRoot'
	instVarNames: #( btreeRootNode indexObject )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'BtreePlusRoot is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusRoot
removeallclassmethods BtreePlusRoot

doit
(BtreePlusRoot
	subclass: 'RcBtreePlusRoot'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Node-Core';
		comment: 'RcBtreePlusRoot is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods RcBtreePlusRoot
removeallclassmethods RcBtreePlusRoot

doit
(Object
	subclass: 'BtreePlusRootObjectMap'
	instVarNames: #( roots traversalMap cumulativeFactor pivotObject pivotPathTerm )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-PathTerm-Core';
		comment: 'BtreePlusRootObjectMap is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.

Dictionary class for creating reverse lookup map for Btree Plus update operations.';
		immediateInvariant.
true.
%

removeallmethods BtreePlusRootObjectMap
removeallclassmethods BtreePlusRootObjectMap

doit
(Object
	subclass: 'CanonicalObjectManager'
	instVarNames: #( referencingObjectPolicy registries sessionCacheStatOffset )
	classVars: #(  )
	classInstVars: #( default securityPolicy )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Canonicalization';
		comment: 'The Canonical Object Framework provides an optional way to reduce
duplicate instances of equivalent objects in your application. To accomplish
this goal you register a class as being canonicalizable (#''createRegistryFor:'')
and then you can request a canonical object (#''canonicalObjectFor:''). 

To avoid commit conflicts, if a canonical object is not yet in the registry, the 
framework allows overlapping transactions to see different objects as the 
canonical one, but subsequent transactions will see one of the earlier ones.
To ensure that only one object is used, send #''ultimateCanonicalObjectFor:''
and be prepared to handle commit conflicts.

An alternate way to canonicalize objects is to provide a set of objects to the
manager and have it scan them for references to canonicalizable objects
(#''cleanupAll:''). This would typically be used with objects found using a
repository scan (Repository>>#''listReferencesToInstancesOfClasses:toDirectory:'').

Because some objects should not have references arbitrarily replaced (e.g., 
IdentitySets), the framework uses a pluggable policy to decide which
referencing objects can be modified. The default ReferencingObjectPolicy 
bases the decision on the referencing object class.

A special case of object cleanup is #''cleanupWriteSet'' that scans the write
set for the current transaction and replaces references as indicated by the
policy. Thus, a properly configured manager could do appropriate cleanup 
before a commit.

By default, the default instance of CanonicalObjectManager has world write 
permission so that canonical objects can be created by any session and shared.
You can modify this using CanonicalObjectManager class>>#securityPolicy:';
		immediateInvariant.
true.
%

removeallmethods CanonicalObjectManager
removeallclassmethods CanonicalObjectManager

doit
(Object
	subclass: 'CanonicalObjectPolicy'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Canonicalization';
		comment: 'CanonicalObjectPolicy is internal to the Canonical Object Framework.
It may be that in the future we will allow pluggable policies for some
canonicalization behavior.';
		immediateInvariant.
true.
%

removeallmethods CanonicalObjectPolicy
removeallclassmethods CanonicalObjectPolicy

doit
(Object
	subclass: 'CanonicalObjectRegistry'
	instVarNames: #( canonicalObjectPolicy manager potentialCanonicalObjects registry )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Canonicalization';
		comment: 'CanonicalObjectRegistry is internal to the Canonical Object Framework.
There may be one registry for each ClassHistory and it holds a collection 
(a KeyValueDictionary) of the ultimate canonical objects and a collection 
of potentialCanonicalObjects (an RcIdentityBag). If an equivalent object 
is not found in the registry, then the framework scans the potentials for
an equivalent object (which could have been added by any session). If
an equivalent object is found it is returned; otherwise the new object is
added to the potentials and returned.

At some time when conflicts are considered unlikely, one can send 
#''canonicalizePotentialCanonicalObjects'' to the CanonicalObjectManager 
and the potentials will be added to the registry (improving subsequent
lookup performance).';
		immediateInvariant.
true.
%

removeallmethods CanonicalObjectRegistry
removeallclassmethods CanonicalObjectRegistry

doit
(Object
	subclass: 'GsEventLog'
	instVarNames: #( entryArray newEntriesInvariant )
	classVars: #(  )
	classInstVars: #( CurrentLog )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'Instances of GsEventLog hold collections of log entries, each representing an item recorded 
in a logical log file.  There is a shared, system-wide instance in the class instance variable. 
All users are allowed to add and remove entries from this log.  

The entries are stored in an instance of RcArray, allowing concurrent writes of log entries.  
Note that the order of elements is based on the order in which the commits occurred, 
while entry timestamps reflect the time at which the entry was created.

GsEventLog may hold both application (user) events and system events.  
User entires can be added in two ways: class convenience methods such as logError:, logInfo, etc., 
or by creating an instance of GsEventLogEntry and sending addToLog.  
System events should be added only by GemStone code (no events are added at this time).
To restrict modifying or removing events, execute GsEventLog entriesUnmodifiable.  
After this is executed, new entries to the log are made invariant and the standard delete methods 
will not delete them.  However, they are not protected from delete using private delete protocol. 
System events are also protected from modification or delete, other than using private delete 
protocol.

Removing entries is subject to commit conflict, it is recommended to lock the event log prior to 
delete.';
		immediateInvariant.
true.
%

removeallmethods GsEventLog
removeallclassmethods GsEventLog

doit
(Object
	subclass: 'GsEventLogEntry'
	instVarNames: #( pid timestamp label priority object tag )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsEventLogEntry represents a single entry in a GsEventLog. Instances of GsEventLogEntry are user 
or application-specific events. 
By default, GsEventLogEntries are modifiable.  They can be made invariant in which case they are 
not deleted by default protocol.
It is supported to create custom subclasses with additional fields or different behavior.

GsEventLogEntries have the following fields:

 pid - SmallInteger, the processId of the session that created this entry
 timestamp - DateAndTime, the timestamp that this event was created.
 label - String, a string describing this entry
 priority - SmallInteger (required), the priority, see Class methods errorPrioity, warningPriority, etc.
 object - any object
 tag - any symbol';
		immediateInvariant.
true.
%

removeallmethods GsEventLogEntry
removeallclassmethods GsEventLogEntry

doit
(GsEventLogEntry
	subclass: 'GsEventLogSystemEntry'
	instVarNames: #( subsystem )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsEventLogSystemEntry represents a single, system-generated entry in a GsEventLog. 
Instances of GsEventLogSystemEntry should only be generated by GemStone code. 
They are not deleted from a GsEventLog using default protocol.
';
		immediateInvariant.
true.
%

removeallmethods GsEventLogSystemEntry
removeallclassmethods GsEventLogSystemEntry

doit
(Object
	subclass: 'GsIndexedQueryEvaluator'
	instVarNames: #( index doBlock )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Evaluator-Core';
		comment: 'GsIndexedQueryEvaluator is an abstract class that implements the behavior used to 
 evaluate queries against UnordedCollections that have been indexed. This class is
 used in the internal implementation of indexing and should not be modified.';
		immediateInvariant.
true.
%

removeallmethods GsIndexedQueryEvaluator
removeallclassmethods GsIndexedQueryEvaluator

doit
(GsIndexedQueryEvaluator
	subclass: 'GsEqualityIndexQueryEvaluator'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Evaluator-Core';
		comment: 'GsEqualityIndexQueryEvaluator is a concrete class that implements the behavior used to 
 evaluate queries against UnordedCollections that have equality indexes. This class is
 used in the internal implementation of indexing and should not be modified.';
		immediateInvariant.
true.
%

removeallmethods GsEqualityIndexQueryEvaluator
removeallclassmethods GsEqualityIndexQueryEvaluator

doit
(GsIndexedQueryEvaluator
	subclass: 'GsIdentityIndexQueryEvaluator'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Evaluator-Core';
		comment: 'GsIdentityIndexQueryEvaluator is a concrete class that implements the behavior used to 
 evaluate queries against UnordedCollections that have identity indexes. This class is
 used in the internal implementation of indexing and should not be modified.';
		immediateInvariant.
true.
%

removeallmethods GsIdentityIndexQueryEvaluator
removeallclassmethods GsIdentityIndexQueryEvaluator

doit
(Object
	subclass: 'GsIndexSpec'
	instVarNames: #( specs defaultOptions )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsIndexSpec defines the specification used to create one or more indexes on a collection.  Instance protocol for GsIndexSpec includes methods to create particular kinds of indexes with specific features.  

Once the indexes are defined in the GsIndexSpec, the indexes can be created on a particular collection.  
Printing a GsIndexSpec outputs a string that can be used to recreate the same set of indexes and features.

Instance Variables
  specs -- Array of specifications for individual indexes
  defaultOptions -- instance of GsIndexOptions';
		immediateInvariant.
true.
%

removeallmethods GsIndexSpec
removeallclassmethods GsIndexSpec

doit
(Object
	subclass: 'GsOptions'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsOptions is part of the Indexing and Querying subsystem.  It is an abstract superclass for GsQueryOptions and GsIndexOptions, providing behavior for merging and subtracting between instances. ';
		immediateInvariant.
true.
%

removeallmethods GsOptions
removeallclassmethods GsOptions

doit
(GsOptions
	subclass: 'GsIndexOptions'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsIndexOptions is part of the Indexing and Querying subsystem.  This class encapsulates the optional refinements that may be used when creating a particular index on a collection.  Each GsIndexSpec has an instance of GsIndexOptions, either the default one or an instance that is created and included in the GsIndexSpec specification method.

GsIndexOptions are stored in dynamic instance variables for ease of migration; all are false by default:
   reducedConflict
   optionalPathTerms
';
		immediateInvariant.
true.
%

removeallmethods GsIndexOptions
removeallclassmethods GsIndexOptions

doit
(GsOptions
	subclass: 'GsQueryOptions'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsQueryOptions is part of the Indexing and Querying subsystem.  This class encapsulates the optional refinements that may be used when creating a particular query.  Each GsQuery has an associated instance of GsQueryOptions, either the default one or an instance that is created and included in the GsQuery specification method.

GsQueryOptions are stored in dynamic instance variables for ease of migration.  The following are false by default:
   cacheQueryResult
   optionalPathTerms
The following apply to optimization of queries and are true by default:
   applyDeMorgansLaws
   autoOptimize
   consolidateEnumerablePredicates
   consolidateRangePredicates
   consolidateUnaryConstantPredicates
   normalizePredicates
   removeRedundantPredicates
   reorderPredicates
   transformCommonPaths
';
		immediateInvariant.
true.
%

removeallmethods GsQueryOptions
removeallclassmethods GsQueryOptions

doit
(Object
	subclass: 'GsQuery'
	instVarNames: #( nsc formula originalFormula queryOptions queryResult collator )
	classVars: #( DefaultOptimizerClass DefaultQueryOptions )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQuery is an abstraction of a query and conceptually of the query results.  

An instance of GsQuery is created based on:
  -- a string following query syntax,
  -- from a select block as used in the legacy indexing system, or
  --  from a formula output from another queery.  
This GsQuery must be bound to a collection, and any variables resolved, before it can be used as a query.  

Once it is fully bound, it can be treated as a collection of the results.  
However, note that operations will execute the query.';
		immediateInvariant.
true.
%

removeallmethods GsQuery
removeallclassmethods GsQuery

doit
(Object
	subclass: 'GsQueryFormula'
	instVarNames: #( nsc collator pathTermsRequired )
	classVars: #( ComparisonSelectorMap InverseOperatorMap NegatedOperatorMap )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The abstract class GsQueryFormula represents a formula in a GsQuery. A formula is composed of one or more predicates (instance of GsAbstractQueryPredicate).';
		immediateInvariant.
true.
%

removeallmethods GsQueryFormula
removeallclassmethods GsQueryFormula

doit
(GsQueryFormula
	subclass: 'GsAbstractQueryPredicate'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The abstract class GsAbstractQueryPredicate is a predicate in a GsQueryFormula. A predicate is a boolean expression composed of two operands and an operator (GsQueryPredicate) or three operands and two operators (GsRangeQueryPredicate).

An operand may be a literal (instance of GsConstantReferenceAssociation), a variable (instance of GsVariableReferenceAssociation) or a path (instance of a GsQueryPathReferenceAssociation). 

A path operand is expected to be an instance of a GsQueryPathReferenceAssociation.
An operator may be one of the standard comparison operators: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsAbstractQueryPredicate
removeallclassmethods GsAbstractQueryPredicate

doit
(GsAbstractQueryPredicate
	subclass: 'GsQueryPredicate'
	instVarNames: #( operand1 evaluator1 operator operand2 )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The abstract class GsQueryPredicate is a predicate in a GsQueryFormula. This class applies an operator to two operands.

Operands may be a literal (instance of GsConstantReferenceAssociation), a variable (instance of GsVariableReferenceAssociation), or a path (instance of a GsQueryPathReferenceAssociation).

An operator may be one of the following: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsQueryPredicate
removeallclassmethods GsQueryPredicate

doit
(GsQueryPredicate
	subclass: 'GsConstantConstantPredicate'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsConstantConstantPredicate is a predicate in a GsQueryFormula. This class is a concrete subclass of GsQueryPredicate and applies an operator to two constant operands. 

A constant operand may be a literal (instance of GsConstantReferenceAssociation) or a variable (instance of GsVariableReferenceAssociation).

An operator may be one of the following: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsConstantConstantPredicate
removeallclassmethods GsConstantConstantPredicate

doit
(GsQueryPredicate
	subclass: 'GsConstantPathPredicate'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsConstantPathPredicate is a predicate in a GsQueryFormula. This class is a concrete subclass of GsQueryPredicate and applies an operator to a constant operand and a path operand. 

A constant operand may be a literal (instance of GsConstantReferenceAssociation) or a variable (instance of GsVariableReferenceAssociation). 

A path operand is expected to be an instance of a GsQueryPathReferenceAssociation.

An operator may be one of the following: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsConstantPathPredicate
removeallclassmethods GsConstantPathPredicate

doit
(GsQueryPredicate
	subclass: 'GsPathConstantPredicate'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsPathConstantPredicate is a predicate in a GsQueryFormula. This class is a concrete subclass of GsQueryPredicate and applies an operator to a path operand and a constant operand. 

A constant operand may be a literal (instance of GsConstantReferenceAssociation) or a variable (instance of GsVariableReferenceAssociation). 

A path operand is expected to be an instance of a GsQueryPathReferenceAssociation.

An operator may be one of the following: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsPathConstantPredicate
removeallclassmethods GsPathConstantPredicate

doit
(GsPathConstantPredicate
	subclass: 'GsPreparedPathConstantPredicate'
	instVarNames: #( cachedClasses cachedOffsets preparedOperator preparedConstant preparedEvaluator preparedEvaluatorSize )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Query-Core';
		comment: 'GsPreparedPathConstantPredicate is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsPreparedPathConstantPredicate
removeallclassmethods GsPreparedPathConstantPredicate

doit
(GsQueryPredicate
	subclass: 'GsPathPathPredicate'
	instVarNames: #( evaluator2 )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsPathPathPredicate is a predicate in a GsQueryFormula. This class is a concrete subclass of GsQueryPredicate and applies an operator to two path operands. 

A path operand is expected to be an instance of a GsQueryPathReferenceAssociation.

An operator may be one of the following: < > = == <= >= ~= ~~.';
		immediateInvariant.
true.
%

removeallmethods GsPathPathPredicate
removeallclassmethods GsPathPathPredicate

doit
(GsAbstractQueryPredicate
	subclass: 'GsRangeQueryPredicate'
	instVarNames: #( operand1 operator1 path operator2 operand2 evaluator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsRangeQueryPredicate is a predicate in a GsQueryFormula. This class is a concrete subclass of GsAbstractQueryPredicate and applies two operators, two constant operands and a path operand.

The constant operands may be a literal (instance of GsConstantReferenceAssociation) or a variable (instance of GsVariableReferenceAssociation).

The path operand is expected to be an instance of a GsQueryPathReferenceAssociation.

Each operator may be one of the range comparison operators: < > <= >=. To qualify as a normalized GsRangeQueryPredicate, if one of the operators is < or <= then the other operator must also be  < or <=, alternately, if one of the operators is > or >= then the other operator must also be  > or >=. ';
		immediateInvariant.
true.
%

removeallmethods GsRangeQueryPredicate
removeallclassmethods GsRangeQueryPredicate

doit
(GsRangeQueryPredicate
	subclass: 'GsPreparedRangeQueryPredicate'
	instVarNames: #( cachedClasses cachedOffsets preparedOperator1 preparedConstant1 preparedOperator2 preparedConstant2 preparedEvaluator preparedEvaluatorSize )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Query-Core';
		comment: 'GsPreparedRangeQueryPredicate is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing.';
		immediateInvariant.
true.
%

removeallmethods GsPreparedRangeQueryPredicate
removeallclassmethods GsPreparedRangeQueryPredicate

doit
(GsQueryFormula
	subclass: 'GsCompoundClause'
	instVarNames: #( clause1 operator clause2 )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsCompoundClause is a predicate in a GsQueryFormula. This class applies an operator to two clauses or predicates. Each clause or predicate is expected to be a subclass of GsQueryFormula.

An operator may be one of the following: & |.';
		immediateInvariant.
true.
%

removeallmethods GsCompoundClause
removeallclassmethods GsCompoundClause

doit
(GsQueryFormula
	subclass: 'GsUnaryClause'
	instVarNames: #( clause operator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class GsUnaryClause is a predicate in a GsQueryFormula. This class applies the unary operator #not to a clause or a predicate. Each clause or predicate is expected to be a subclass of GsQueryFormula.';
		immediateInvariant.
true.
%

removeallmethods GsUnaryClause
removeallclassmethods GsUnaryClause

doit
(Object
	subclass: 'GsQueryFormulaVisitor'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryFormulaVisitor is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryFormulaVisitor
removeallclassmethods GsQueryFormulaVisitor

doit
(GsQueryFormulaVisitor
	subclass: 'GsAbstractQueryOptimizer'
	instVarNames: #( formula nsc queryOptions )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsAbstractQueryOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsAbstractQueryOptimizer
removeallclassmethods GsAbstractQueryOptimizer

doit
(GsAbstractQueryOptimizer
	subclass: 'GsClassicQueryBlockOptimizer'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsClassicQueryBlockOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsClassicQueryBlockOptimizer
removeallclassmethods GsClassicQueryBlockOptimizer

doit
(GsClassicQueryBlockOptimizer
	subclass: 'Gs32Optimizer'
	instVarNames: #( transformed )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'Gs32Optimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods Gs32Optimizer
removeallclassmethods Gs32Optimizer

doit
(GsAbstractQueryOptimizer
	subclass: 'GsClauseOptimizer'
	instVarNames: #( predicates )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsClauseOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsClauseOptimizer
removeallclassmethods GsClauseOptimizer

doit
(GsClauseOptimizer
	subclass: 'Gs32DisjunctiveClauseOptimizer'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'Gs32DisjunctiveClauseOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods Gs32DisjunctiveClauseOptimizer
removeallclassmethods Gs32DisjunctiveClauseOptimizer

doit
(GsClauseOptimizer
	subclass: 'Gs32UnaryConstantPredicateOptimizer'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'Gs32UnaryConstantPredicateOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods Gs32UnaryConstantPredicateOptimizer
removeallclassmethods Gs32UnaryConstantPredicateOptimizer

doit
(GsClauseOptimizer
	subclass: 'GsClassicConjunctiveClauseOptimizer'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsClassicConjunctiveClauseOptimizer is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsClassicConjunctiveClauseOptimizer
removeallclassmethods GsClassicConjunctiveClauseOptimizer

doit
(GsClauseOptimizer
	subclass: 'GsConjunctiveClauseConjoinSetChecker'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsConjunctiveClauseConjoinSetChecker is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsConjunctiveClauseConjoinSetChecker
removeallclassmethods GsConjunctiveClauseConjoinSetChecker

doit
(GsClauseOptimizer
	subclass: 'GsStreamableConjunctiveClauseChecker'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsStreamableConjunctiveClauseChecker is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsStreamableConjunctiveClauseChecker
removeallclassmethods GsStreamableConjunctiveClauseChecker

doit
(GsAbstractQueryOptimizer
	subclass: 'GsQueryConjoinSetChecker'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryConjoinSetChecker is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryConjoinSetChecker
removeallclassmethods GsQueryConjoinSetChecker

doit
(GsAbstractQueryOptimizer
	subclass: 'GsStreamableQueryChecker'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsStreamableQueryChecker is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsStreamableQueryChecker
removeallclassmethods GsStreamableQueryChecker

doit
(Object
	subclass: 'GsQueryLiteral'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryLiteral is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryLiteral
removeallclassmethods GsQueryLiteral

doit
(GsQueryLiteral
	subclass: 'GsQueryLiteralArray'
	instVarNames: #( isByteArray contents )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryLiteralArray is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryLiteralArray
removeallclassmethods GsQueryLiteralArray

doit
(GsQueryLiteral
	subclass: 'GsQueryLiteralValue'
	instVarNames: #( value )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryLiteralValue is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryLiteralValue
removeallclassmethods GsQueryLiteralValue

doit
(Object
	subclass: 'GsSingleRefPathFinder'
	instVarNames: #( searchObjects limitObjects allSearches numSearchesActive numPassesDone otScanDone printToLog scanStartTime opStartTime maxThreads lockWaitTime pageBufferSize percentCpuLimit maxLimitSetDescendantObjs maxLimitSetDescendantLevels )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsSingleRefPathFinder is a class used to determine how each object in a list
are connected to the repository.  It is typically used to determine why objects
expected to be collected by global garbage collection (markForCollection) were
not removed.  The list of objects connecting an object to the repository is
called a reference path.  An object may have more than one reference path,
however this class only determines one reference path for every search object.

Instance Variables:

searchObjects - a GsBitmap containing all objects for which reference paths will
be searched.

limitObjects - an array of GsBitmaps.  The first element contains the base limit
set of the search, that is, a group of objects known to be
connected to the repository.  The base limit set is returned by
the method SystemRepository buildLimitSetForRefPathScan.  The
next element in the array are the children of the based limit
set, and the next are the grandchildren, etc.

allSearches - anArray containing instances of GsSingleRefPathFinderForObject.  One
instance for each search object.

numSearchesActive - number of searches not yet completed.

otScanDone - Boolean indicating if the object table scan has been completed.
This is the first phase of the scan and only runs once.

printToLog - Boolean indicating if messages and results are to be written to
stdout of the process.

scanStartTime - A SmallInteger representing the timestamp of when the scan
started.

opStartTime - A SmallInteger - representing the timestamp of when an operation
started.  Used to print elapsed times to the log.

maxThreads - number of threads to use to perform the scan.

lockWaitTime - number of seconds to wait when acquiring the garbage collection
lock before starting the scan.

pageBufferSize - number of 16 KB pages each thread will buffer.  Must be a power
of 2.

percentCpuLimit - percentage of total system CPU which the scan may consume.

maxLimitSetDescendantObjs - maximum size of a generation of objects reachable
from the limit set.  At the beginning of the scan, the default limit set is
traversed until the size of the generation exceeds this value.  Default is
one million objects.

maxLimitSetDescendantLevels - maximum number of generations traversed to build
the limit set.  At the beginning of the scan, the default limit set is
traversed until the number of generations searched this value.  Default is 
unlimited.

Steps to find a reference path:

1) Create an instance with default settings:
| inst |
inst := GsSingleRefPathFinder newForSearchObjects: (Array with: mySearchObject)

2) Run the scan
inst runScan

3) Build the result objects (An Array of GsSingleRefPathResult objects)
inst buildResultObjects

The GsSingleRefPathResult object is the equivalent of the structured Array 
returned by findReferencePathToObj* methods in earlier releases.

4) For display, collect the results as strings:
<resultObjs> collect: [:e | e resultString]

For example:

| inst |
inst := GsSingleRefPathFinder newForSearchObjects: { myObj }.
inst runScan.
(inst buildResultObjects) 
   collect: [:e | e resultString]

Steps 2-4 can be done using inst scanAndReport. For example:

(GsSingleRefPathFinder newForSearchObjects: { myObj }) scanAndReport
';
		immediateInvariant.
true.
%

removeallmethods GsSingleRefPathFinder
removeallclassmethods GsSingleRefPathFinder

doit
(Object
	subclass: 'GsSingleRefPathFinderForObject'
	instVarNames: #( completed isDead refPathFinder limitOopsFound searchOopsUnion searchOop resultObject parentBitmaps )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsSingleRefPathFinderForObject holds the state of a reference path search for one
search object.  It has the following instance variables:

completed - A Boolean indicating if the search for searchOop has finished.
True if the reference path was found or if the object was
determined to be dead.

isDead - A Boolean indicating if the object is unreachable and eligible for
garbage collection.

refPathFinder - Reference to the instance of GsSingleRefPathFinder that created
this object.

limitOopsFound - a GsBitmap containing the objects in the limit set which can
be traversed to reach searchOop.

searchOopsUnion - a GsBitmap containing all objects already searched for in
this reference path scan.

searchOop - the object for which the reference path is to be found.

resultObject - an instance of GsSingleRefPathResult which contains the
reference path to searchOop.

parentBitmaps - an Array of GsBitmaps which contain ancestors of searchOop.
';
		immediateInvariant.
true.
%

removeallmethods GsSingleRefPathFinderForObject
removeallclassmethods GsSingleRefPathFinderForObject

doit
(Object
	subclass: 'PPCharSetPredicate'
	instVarNames: #( block classification )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Tools';
		immediateInvariant.
true.
%

removeallmethods PPCharSetPredicate
removeallclassmethods PPCharSetPredicate

doit
(Object
	subclass: 'PPContext'
	instVarNames: #( stream root properties globals furthestFailure )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		comment: 'A PPContext is provides contextual information to the parsing function.

Instance Variables
	globals:		<Dictionary>
	properties:		<Dictionary>
	root:		<PPParser>
	stream:		<PPStream>
	furthestFailure:	<PPFailure>

globals
	- properties that are not restored after backtracking

properties
	- properties that are restored after backtracking

root
	- the root parser

stream
	- input stream
';
		immediateInvariant.
true.
%

removeallmethods PPContext
removeallclassmethods PPContext

doit
(Object
	subclass: 'PPContextMemento'
	instVarNames: #( stream position properties )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		immediateInvariant.
true.
%

removeallmethods PPContextMemento
removeallclassmethods PPContextMemento

doit
(Object
	subclass: 'PPFailure'
	instVarNames: #( message context position )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		comment: 'The failure object in PetitParser. It is the only class that responds to #isPetitFailure with true. It contains an error message and a position of the occurrence of the failure.

Instance Variables:
	message	<String>	The error message of this failure.
	position	<Integer>	The position of this failure in the input stream.
';
		immediateInvariant.
true.
%

removeallmethods PPFailure
removeallclassmethods PPFailure

doit
(Object
	subclass: 'PPForwardingParser'
	instVarNames: #( forwardee )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'Forwards (almost) all messages to its forwardee parser, making them for most purposes the same object.
This is used to simulate the one-way become that is used in other ports of PetitParser to resolve parsers.';
		immediateInvariant.
true.
%

removeallmethods PPForwardingParser
removeallclassmethods PPForwardingParser

doit
(Object
	subclass: 'PPMemento'
	instVarNames: #( result count context )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		comment: 'PPMemento is an internal class used by PPMemoizedParser to cache results and detect left-recursive calls.

Instance Variables:
	result	<Object>	The cached result.
	count	<Integer>	The number of recursive cycles followed.
	context	<PPContext>	The context of the cached result in the input stream.';
		immediateInvariant.
true.
%

removeallmethods PPMemento
removeallclassmethods PPMemento

doit
(Object
	subclass: 'PPParser'
	instVarNames: #( properties )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'An abstract parser for all parsers in PetitParser. Subclasses implement #parseOn: to perform 
the actual recursive-descent parsing. All parsers support a variety of methods to perform an 
actual parse, see the methods in the #parsing protocol. Parsers are combined with a series 
of operators that can be found in the #operations protocol.

Instance Variables:
	properties	<Dictionary>	Stores additional state in the parser object.

GemStone implementation notes:

CharacterCollection>>#asParser
	We have this instead of String>>#asParser
Collection>>#asParser
	We use #isKindOf: instead of #isCharacter
DoubleByteSymbol>>#asParser
	We added this
Interval>>#asParser
	We use #isKindOf: instead of #isCharacter
PositionableStream
	#peekTwice and #asPetitStream moved to PositionableStreamPortable
PositionableStreamPortable>>#collection
	We added as compatibility with PositionableStream in Pharo/Squeak
PPActionParser>>#setBlock:
	Modified to support Symbol as argument
PPCompositeParser>>#productionAt:ifAbsent:
	Remove #asString since we store instVarNames as symbols
PPForwardingParser
	We use this instead of #becomeForward: in PPParser>>#def:
PPLiteralObjectParser>>#caseInsensitive
	We use #isEquivalent: instead of #sameAs:
PPLiteralSequenceParser>>#caseInsensitive
	We use #isEquivalent: instead of #sameAs:
PPParser>>#def:
	Modified since we dont have #becomeForward:
PPParser>>#queryToken
	Added to support GsQueryTokenParser
PPRepeatingParser>>#initialize
	Modified to use #maximumValue instead of #maxValue
PPRepeatingParser>>#printOn:
	Modified to use #maximumValue instead of #maxValue
PPSequenceParser>>#permutation:
	Modified to use #_isInteger instead of #isInteger
PPStream
	Superclass changed to ReadStream Portable
PPStream>>#back and #peekBack
	Added to match Pharo/Squeak PositionableStream
PPStream>>#printOn:
	Modified to avoid non-Ascii character in source code
PPToken
	Remove NewLineParser from class variable (permissions and commit conflicts)
QuadByteSymbol>>#asParser
	Added
String>>#asParser
	Moved to CharacterCollection
Text>>#asPetitStream
	Not supported

PPParser>>#matchingRangesIn:do:
	Should change to match since no recognizable difference
';
		immediateInvariant.
true.
%

removeallmethods PPParser
removeallclassmethods PPParser

doit
(PPParser
	subclass: 'PPDelegateParser'
	instVarNames: #( parser )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that delegates to another parser.

Instance Variables:
	parser	<PPParser>	The parser to delegate to.';
		immediateInvariant.
true.
%

removeallmethods PPDelegateParser
removeallclassmethods PPDelegateParser

doit
(PPDelegateParser
	subclass: 'GsQueryErrorHandlingParser'
	instVarNames: #( errorMessage nestMessages )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsQueryErrorHandlingParser is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryErrorHandlingParser
removeallclassmethods GsQueryErrorHandlingParser

doit
(PPDelegateParser
	subclass: 'PPActionParser'
	instVarNames: #( block )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that performs an action block with the successful parse result of the delegate.

Instance Variables:
	block	<BlockClosure>	The action block to be executed.
';
		immediateInvariant.
true.
%

removeallmethods PPActionParser
removeallclassmethods PPActionParser

doit
(PPActionParser
	subclass: 'PPWrappingParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that performs an action block upon activation with the stream and a continuation block.';
		immediateInvariant.
true.
%

removeallmethods PPWrappingParser
removeallclassmethods PPWrappingParser

doit
(PPDelegateParser
	subclass: 'PPAndParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'The and-predicate, a parser that succeeds whenever its delegate does, but does not consume the input stream [Parr 1994, 1995].';
		immediateInvariant.
true.
%

removeallmethods PPAndParser
removeallclassmethods PPAndParser

doit
(PPDelegateParser
	subclass: 'PPCompositeParser'
	instVarNames: #( dependencies )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Tools';
		comment: 'A PPCompositeParser is composed parser built from various primitive parsers. 

Every production in the receiver is specified as a method that returns its parser. Note that every production requires an instance variable of the same name, otherwise the production is not cached and cannot be used in recursive grammars. Productions should refer to each other by reading the respective inst-var. Note: these inst-vars are typically not written, as the assignment happens in the initialize method using reflection.

The start production is defined in the method start. It is aliased to the inst-var parser defined in the superclass of PPCompositeParser.';
		immediateInvariant.
true.
%

removeallmethods PPCompositeParser
removeallclassmethods PPCompositeParser

doit
(PPCompositeParser
	subclass: 'GsQueryGrammar'
	instVarNames: #( arrayItem arrayLiteral arrayLiteralArray binary byteLiteral byteLiteralArray char charLiteral charToken expression falseLiteral falseToken identifier identifierToken literal nilLiteral nilToken not notMessage notToken number numberLiteral numberToken parenExpression parenPredicate path pathToken predicateExpression predicateMessage primary primaryIdentifier rangePrimary rangePredicateExpression relop relopToken queryPath queryPathToken simplePredicateExpression string stringLiteral stringToken symbol symbolLiteral symbolLiteralArray trueLiteral trueToken variable )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryGrammar is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryGrammar
removeallclassmethods GsQueryGrammar

doit
(GsQueryGrammar
	subclass: 'GsQueryParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryParser is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryParser
removeallclassmethods GsQueryParser

doit
(PPDelegateParser
	subclass: 'PPConditionalParser'
	instVarNames: #( block )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPConditionalParser is a delegate parser that evaluates a block and if that returns true, the delegate parser is invoked and its result returned. If the block evaluates to false, the PPFailure is returned.

The block accepts one argument, context.

E.g.
    (''a'' asParser if: [ :ctx | (ctx propertyAt: #myProperty) isNotNil ]) parse: ''a''';
		immediateInvariant.
true.
%

removeallmethods PPConditionalParser
removeallclassmethods PPConditionalParser

doit
(PPDelegateParser
	subclass: 'PPEndOfInputParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that succeeds only at the end of the input stream.';
		immediateInvariant.
true.
%

removeallmethods PPEndOfInputParser
removeallclassmethods PPEndOfInputParser

doit
(PPDelegateParser
	subclass: 'PPExpressionParser'
	instVarNames: #( operators )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Tools';
		comment: 'A PPExpressionParser is a parser to conveniently define an expression grammar with prefix, postfix, and left- and right-associative infix operators.

The following code initializes a parser for arithmetic expressions. First we instantiate an expression parser, a simple parser for expressions in parenthesis and a simple parser for integer numbers.

	expression := PPExpressionParser new.
	parens := $( asParser token trim , expression , $) asParser token trim 
		==> [ :nodes | nodes second ].
	integer := #digit asParser plus token trim
		==> [ :token | token value asInteger ].
	
Then we define on what term the expression grammar is built on:

	expression term: parens / integer.
	
Finally we define the operator-groups in descending precedence. Note, that the action blocks receive both, the terms and the parsed operator in the order they appear in the parsed input. 
	
	expression
		group: [ :g |
			g prefix: $- asParser token trim do: [ :op :a | a negated ] ];
		group: [ :g |
			g postfix: ''++'' asParser token trim do: [ :a :op | a + 1 ].
			g postfix: ''--'' asParser token trim do: [ :a :op | a - 1 ] ];
		group: [ :g |
			g right: $^ asParser token trim do: [ :a :op :b | a raisedTo: b ] ];
		group: [ :g |
			g left: $* asParser token trim do: [ :a :op :b | a * b ].
			g left: $/ asParser token trim do: [ :a :op :b | a / b ] ];
		group: [ :g |
			g left: $+ asParser token trim do: [ :a :op :b | a + b ].
			g left: $- asParser token trim do: [ :a :op :b | a - b ] ].
		
After evaluating the above code the ''expression'' is an efficient parser that evaluates examples like:

	expression parse: ''-8++''.
	expression parse: ''1+2*3''.
	expression parse: ''1*2+3''.
	expression parse: ''(1+2)*3''.
	expression parse: ''8/4/2''.
	expression parse: ''8/(4/2)''.
	expression parse: ''2^2^3''.
	expression parse: ''(2^2)^3''.
	
Instance Variables:
	operators	<Dictionary>	The operators defined in the current group.';
		immediateInvariant.
true.
%

removeallmethods PPExpressionParser
removeallclassmethods PPExpressionParser

doit
(PPDelegateParser
	subclass: 'PPFlattenParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that answers a flat copy of the range my delegate parses.';
		immediateInvariant.
true.
%

removeallmethods PPFlattenParser
removeallclassmethods PPFlattenParser

doit
(PPFlattenParser
	subclass: 'PPTokenParser'
	instVarNames: #( tokenClass )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that answers a token of the range my delegate parses.

Instance Variables:
	tokenClass	<PPToken class>	The token sub-class to be used.';
		immediateInvariant.
true.
%

removeallmethods PPTokenParser
removeallclassmethods PPTokenParser

doit
(PPTokenParser
	subclass: 'GsQueryTokenParser'
	instVarNames: #(  )
	classVars: #( SeparatorPredicate )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'GsQueryTokenParser is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods GsQueryTokenParser
removeallclassmethods GsQueryTokenParser

doit
(PPDelegateParser
	subclass: 'PPMemoizedParser'
	instVarNames: #( buffer identifier )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A memoized parser, for refraining redundant computations.

Instance Variables:
	stream	<PositionableStream>	The stream of the associated memento objects.
	buffer	<Array of: PPMemento>	The buffer of memento objects.
';
		immediateInvariant.
true.
%

removeallmethods PPMemoizedParser
removeallclassmethods PPMemoizedParser

doit
(PPDelegateParser
	subclass: 'PPNotParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'The not-predicate, a parser that succeeds whenever its delegate does not, but consumes no input [Parr 1994, 1995].';
		immediateInvariant.
true.
%

removeallmethods PPNotParser
removeallclassmethods PPNotParser

doit
(PPDelegateParser
	subclass: 'PPOptionalParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that optionally parsers its delegate, or answers nil.';
		immediateInvariant.
true.
%

removeallmethods PPOptionalParser
removeallclassmethods PPOptionalParser

doit
(PPDelegateParser
	subclass: 'PPRepeatingParser'
	instVarNames: #( min max )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'An abstract parser that repeatedly parses between ''min'' and ''max'' instances of its delegate. The default configuration parses an infinite number of elements, as ''min'' is set to 0 and ''max'' to infinity (SmallInteger maxVal).

Instance Variables:
	min	<Integer>	The minimum number of repetitions.
	max	<Integer>	The maximum number of repetitions.';
		immediateInvariant.
true.
%

removeallmethods PPRepeatingParser
removeallclassmethods PPRepeatingParser

doit
(PPRepeatingParser
	subclass: 'PPLimitedRepeatingParser'
	instVarNames: #( limit )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'An abstract parser that repeatedly parses between ''min'' and ''max'' instances of my delegate and that requires the input to be completed with a specified parser ''limit''. Subclasses provide repeating behavior as typically seen in regular expression implementations (non-blind).

Instance Variables:
	limit	<PPParser>	The parser to complete the input with.';
		immediateInvariant.
true.
%

removeallmethods PPLimitedRepeatingParser
removeallclassmethods PPLimitedRepeatingParser

doit
(PPLimitedRepeatingParser
	subclass: 'PPGreedyRepeatingParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A greedy repeating parser, commonly seen in regular expression implementations. It aggressively consumes as much input as possible and then backtracks to meet the ''limit'' condition.

This class essentially implements the iterative version of the following recursive parser composition:

	| parser |
	parser := PPChoiceParser new.
	parser setParsers: (Array
		with: (self , parser map: [ :each :rest | rest addFirst: each; yourself ])
		with: (limit and ==> [ :each | OrderedCollection new ])).
	^ parser ==> [ :rest | rest asArray ]';
		immediateInvariant.
true.
%

removeallmethods PPGreedyRepeatingParser
removeallclassmethods PPGreedyRepeatingParser

doit
(PPLimitedRepeatingParser
	subclass: 'PPLazyRepeatingParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A lazy repeating parser, commonly seen in regular expression implementations. It limits its consumption to meet the ''limit'' condition as early as possible.

This class essentially implements the iterative version of the following recursive parser composition:

	| parser |
	parser := PPChoiceParser new.
	parser setParsers: (Array
		with: (limit and ==> [ :each | OrderedCollection new ])
		with: (self , parser map: [ :each :rest | rest addFirst: each; yourself ])).
	^ parser ==> [ :rest | rest asArray ]';
		immediateInvariant.
true.
%

removeallmethods PPLazyRepeatingParser
removeallclassmethods PPLazyRepeatingParser

doit
(PPRepeatingParser
	subclass: 'PPPossessiveRepeatingParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'The default repeating parser with standard PEG semantics (i.e. possessive, blind, eager).';
		immediateInvariant.
true.
%

removeallmethods PPPossessiveRepeatingParser
removeallclassmethods PPPossessiveRepeatingParser

doit
(PPDelegateParser
	subclass: 'PPTrimmingParser'
	instVarNames: #( trimmer )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that silently consumes spaces before and after the delegate parser.';
		immediateInvariant.
true.
%

removeallmethods PPTrimmingParser
removeallclassmethods PPTrimmingParser

doit
(PPParser
	subclass: 'PPEndOfFileParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPEndOfFileParser is parser that will will return true if the stream position is at the end, returns failure otherwise.

The diffirenece between PPEndOfFIleParser and PPEndOfInputParser is:
 - PPEndOfFileParser can be created using #eof asParser
 - PPEndOfInputParser can be created by using parser end
 - PPEndOfFileParser does not delegate to any other parser
 - PPEndOfInputParser parsers its delegate and then decides if the input is at the end.

The PPEndOfFileParser can be used to accept some input only if it is at the end of the input, e.g:

   (''a'' asParser, #eof asParser) parse: ''a''
   (''a'' asParser, #eof asParser) parse: ''aa''
';
		immediateInvariant.
true.
%

removeallmethods PPEndOfFileParser
removeallclassmethods PPEndOfFileParser

doit
(PPParser
	subclass: 'PPEndOfLineParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPEndOfLineParser is a parser that does not fail, if the stream position is at the end of a line. It does not consume anything.';
		immediateInvariant.
true.
%

removeallmethods PPEndOfLineParser
removeallclassmethods PPEndOfLineParser

doit
(PPParser
	subclass: 'PPEpsilonParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that consumes nothing and always succeeds.';
		immediateInvariant.
true.
%

removeallmethods PPEpsilonParser
removeallclassmethods PPEpsilonParser

doit
(PPParser
	subclass: 'PPFailingParser'
	instVarNames: #( message )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that consumes nothing and always fails.

Instance Variables:
	message <String>	The failure message.';
		immediateInvariant.
true.
%

removeallmethods PPFailingParser
removeallclassmethods PPFailingParser

doit
(PPParser
	subclass: 'PPListParser'
	instVarNames: #( parsers )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'Abstract parser that parses a list of things in some way (to be specified by the subclasses).

Instance Variables:
	parsers	<SequenceableCollection of: PPParser>	A sequence of other parsers to delegate to.';
		immediateInvariant.
true.
%

removeallmethods PPListParser
removeallclassmethods PPListParser

doit
(PPListParser
	subclass: 'PPChoiceParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that uses the first parser that succeeds.';
		immediateInvariant.
true.
%

removeallmethods PPChoiceParser
removeallclassmethods PPChoiceParser

doit
(PPChoiceParser
	subclass: 'PPLimitedChoiceParser'
	instVarNames: #( limit )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPLimitedChoiceParser is similar to the choice parser except for the fact, that limit must pass if one of the choices passes. This is similar strategy as with the PPLimitedRepeatingParsers.

This way, one can implement choices that successfully parse this (if limit is filled with ''a''):

(''aa'' // ''a'') ''a'' parse: ''aa''

The limit can be automatically filled using elements from either follow or next set (see methods  PPParser>>followSets or PPParser>>nextSets).

Limit is by default epsilon and therefore it behaves as an ordinary ordered choice.

Instance Variables
	limit:		<Object>

limit
	- xxxxx
';
		immediateInvariant.
true.
%

removeallmethods PPLimitedChoiceParser
removeallclassmethods PPLimitedChoiceParser

doit
(PPListParser
	subclass: 'PPSequenceParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that parses a sequence of parsers.';
		immediateInvariant.
true.
%

removeallmethods PPSequenceParser
removeallclassmethods PPSequenceParser

doit
(PPParser
	subclass: 'PPLiteralParser'
	instVarNames: #( literal message )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'Abstract literal parser that parses some kind of literal type (to be specified by subclasses).

Instance Variables:
	literal	<Object>	The literal object to be parsed.
	message	<String>	The error message to be generated.
';
		immediateInvariant.
true.
%

removeallmethods PPLiteralParser
removeallclassmethods PPLiteralParser

doit
(PPLiteralParser
	subclass: 'PPLiteralObjectParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that accepts a single literal object, such as a character. This is the same as the predicate parser ''PPPredicateParser expect: literal'' but slightly more efficient.';
		immediateInvariant.
true.
%

removeallmethods PPLiteralObjectParser
removeallclassmethods PPLiteralObjectParser

doit
(PPLiteralParser
	subclass: 'PPLiteralSequenceParser'
	instVarNames: #( size )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser accepts a sequence of literal objects, such as a String. This is an optimization to avoid having to compose longer sequences from PPSequenceParser.';
		immediateInvariant.
true.
%

removeallmethods PPLiteralSequenceParser
removeallclassmethods PPLiteralSequenceParser

doit
(PPParser
	subclass: 'PPPluggableParser'
	instVarNames: #( block )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A pluggable parser that passes the parser stream into a block. This enables users to perform manual parsing or to embed other parser frameworks into PetitParser.

Instance Variables:
	block	<BlockClosure>	The pluggable one-argument block.
';
		immediateInvariant.
true.
%

removeallmethods PPPluggableParser
removeallclassmethods PPPluggableParser

doit
(PPParser
	subclass: 'PPPredicateParser'
	instVarNames: #( predicate predicateMessage negated negatedMessage )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'An abstract parser that accepts if a given predicate holds.

Instance Variables:
	predicate	<BlockClosure>	The block testing for the predicate.
	predicateMessage	<String>	The error message of the predicate.
	negated	<BlockClosure>	The block testing for the negation of the predicate.
	negatedMessage	<String>	The error message of the negated predicate.';
		immediateInvariant.
true.
%

removeallmethods PPPredicateParser
removeallclassmethods PPPredicateParser

doit
(PPPredicateParser
	subclass: 'PPPredicateObjectParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that accepts if a given predicate on one element of the input sequence holds.';
		immediateInvariant.
true.
%

removeallmethods PPPredicateObjectParser
removeallclassmethods PPPredicateObjectParser

doit
(PPPredicateParser
	subclass: 'PPPredicateSequenceParser'
	instVarNames: #( size )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A parser that accepts if a given predicate on an arbitrary number of elements of the input sequence holds.

Instance Variables:
	size	<Integer>	The number of elements to consume.';
		immediateInvariant.
true.
%

removeallmethods PPPredicateSequenceParser
removeallclassmethods PPPredicateSequenceParser

doit
(PPParser
	subclass: 'PPStartOfLineParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPStartOfLineParser is that does not fail, if the stream position is at the beginning of a line. It does not consume anything.';
		immediateInvariant.
true.
%

removeallmethods PPStartOfLineParser
removeallclassmethods PPStartOfLineParser

doit
(PPParser
	subclass: 'PPStartOfLogicalLineParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPStartOfLogicalLineParser is that does not fail, if the stream position is at the first non-blank character of a line. It does not consume anything.';
		immediateInvariant.
true.
%

removeallmethods PPStartOfLogicalLineParser
removeallclassmethods PPStartOfLogicalLineParser

doit
(PPParser
	subclass: 'PPStartOfWordParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Parsers';
		comment: 'A PPStartOfWordParser is that matches a word boundary.

I return success if no word character preceeds my position and if word chracter succeeds my position.

Word characters are any alphanumeric characters.';
		immediateInvariant.
true.
%

removeallmethods PPStartOfWordParser
removeallclassmethods PPStartOfWordParser

doit
(PPParser
	subclass: 'PPUnresolvedParser'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Tools';
		comment: 'This is a temporary placeholder or forward reference to a parser that has not been defined yet. If everything goes well it will eventually be replaced with the real parser instance.';
		immediateInvariant.
true.
%

removeallmethods PPUnresolvedParser
removeallclassmethods PPUnresolvedParser

doit
(Object
	subclass: 'PPToken'
	instVarNames: #( newLineParser collection start stop value )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		comment: 'PPToken represents a parsed part of the input stream. Contrary to a simple String it remembers where it came from, the original collection and its start and stop position.

Instance Variables:
	collection	<SequenceableCollection>	The collection this token comes from.
	start	<Integer>	The start position in the collection.
	stop	<Integer>	The stop position in the collection.';
		immediateInvariant.
true.
%

removeallmethods PPToken
removeallclassmethods PPToken

doit
(PathEvaluator
	subclass: 'OptionalTermPathEvaluator'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Evaluators';
		comment: 'OptionalTermPathEvaluator is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods OptionalTermPathEvaluator
removeallclassmethods OptionalTermPathEvaluator

doit
(PathEvaluator
	subclass: 'SelectorPathEvaluator'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'SelectorPathEvaluator is part of the Indexing and Querying subsystem. It implements GemStone internals and is not intended for direct use by customers.';
		immediateInvariant.
true.
%

removeallmethods SelectorPathEvaluator
removeallclassmethods SelectorPathEvaluator

doit
(PrivateObject
	subclass: 'Upgrade3Init'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'Upgrade3Init is a class used during image upgrade.  
Methods should only be executed via the image upgrade scripts.';
		immediateInvariant.
true.
%

removeallmethods Upgrade3Init
removeallclassmethods Upgrade3Init

doit
(RcEqualityIndexSpecification
	subclass: 'RcUnicodeIndexSpecification'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Index-Query';
		comment: 'The class RcUnicodeIndexSpecification provides details for specifying an index that is 
reduced-conflict and contains Unicode Strings. Since it contains Unicode Strings, it requires 
a persistent IcuCollator instance associated with the index.';
		immediateInvariant.
true.
%

removeallmethods RcUnicodeIndexSpecification
removeallclassmethods RcUnicodeIndexSpecification

doit
(SequenceableCollection
	byteSubclass: 'Uint16Array'
	classVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'2byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Uint16Array are byte format arrays that store 16 bit unsigned integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Uint16Array
removeallclassmethods Uint16Array

doit
(Uint16Array
	subclass: 'Int16Array'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'signed2byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Int16Array are byte format arrays that store 16 bit signed integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Int16Array
removeallclassmethods Int16Array

doit
(SequenceableCollection
	byteSubclass: 'Uint32Array'
	classVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'4byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Uint32Array are byte format arrays that store 32 bit unsigned integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Uint32Array
removeallclassmethods Uint32Array

doit
(Uint32Array
	subclass: 'Int32Array'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'signed4byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Int32Array are byte format arrays that store 32 bit signed integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Int32Array
removeallclassmethods Int32Array

doit
(SequenceableCollection
	byteSubclass: 'Uint64Array'
	classVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'8byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Uint64Array are byte format arrays that store 64 bit unsigned integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Uint64Array
removeallclassmethods Uint64Array

doit
(Uint64Array
	subclass: 'Int64Array'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'signed8byteWords'  #logCreation )
)
		category: nil;
		comment: 'Instances of Int64Array are byte format arrays that store 64 bit signed integers.
For an instance loaded into memory, the integers are in machine native byte order.';
		immediateInvariant.
true.
%

removeallmethods Int64Array
removeallclassmethods Int64Array

doit
(SortedCollection
	subclass: 'IcuSortedCollection'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'An IcuSortedCollection is a SortedCollection that
encapsulates an IcuCollator to be used when comparing elements.  
Elements must respond to compareTo:collator:  and thus should be 
instances of Utf8, Unicode7, Unicode16, or Unicode32. ';
		immediateInvariant.
true.
%

removeallmethods IcuSortedCollection
removeallclassmethods IcuSortedCollection

doit
(Stream
	subclass: 'BtreePlusReadStream'
	instVarNames: #( currentNode currentIndex currentLastValIndex currentEntrySize endNode endIndex )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Stream-Core';
		comment: 'BtreePlusReadStream supports the composition of query results by providing access
 to a B-tree structure.

 A BtreePlusReadStream can read all the entries of the B-tree one at a time.  Supply
 the root node when you create the stream, and send the ''next'' message to
 read the first node.  Send the ''next'' message repeatedly to iterate over
 the B-tree''s contents, and send the ''atEnd'' message to check if there are
 any more nodes.
';
		immediateInvariant.
true.
%

removeallmethods BtreePlusReadStream
removeallclassmethods BtreePlusReadStream

doit
(BtreePlusReadStream
	subclass: 'BtreePlusGsIndexReadStream'
	instVarNames: #( gsIndex streamQuerySpec optimizedComparison mustCompare )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Stream-Core';
		comment: 'BtreePlusGsIndexReadStream is part of the Indexing and Querying subsystem. It implements 
GemStone internals and is not intended for customer use, by creating instances or by subclassing. ';
		immediateInvariant.
true.
%

removeallmethods BtreePlusGsIndexReadStream
removeallclassmethods BtreePlusGsIndexReadStream

doit
(BtreePlusGsIndexReadStream
	subclass: 'BtreePlusGsReversedIndexReadStream'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Btree-Stream-Core';
		comment: 'BtreePlusGsReversedIndexReadStream is part of the Indexing and Querying subsystem. 
It implements GemStone internals and is not intended for customer use, by creating instances 
or by subclassing';
		immediateInvariant.
true.
%

removeallmethods BtreePlusGsReversedIndexReadStream
removeallclassmethods BtreePlusGsReversedIndexReadStream

! Class implementation for 'GsPathTerm'

!		Instance methods for 'GsPathTerm'

category: 'Private'
method: GsPathTerm
_findAllValuesForIdenticalRootObject: rootObject
	" if index directly on NSC elements or anObject is nil "

	| key tmpList |
	(self indicatesIndexOnNscElements or: [ nil == rootObject ])
		ifTrue: [ key := rootObject ]
		ifFalse: [ key := self _nextObjectFor: rootObject ].
	tmpList := IdentityBag new.
	self updateBtree btreeRoot _findAllValuesForIdenticalKey: key into: tmpList.
	^ (tmpList occurrencesOf: rootObject) <= 1
%

! Class implementation for 'GsOptionalPathTerm'

!		Instance methods for 'GsOptionalPathTerm'

category: 'Adding'
method: GsOptionalPathTerm
addMappingsForObject: anObject root: rootObject logging: aBoolean
	"Add dependency list entries for anObject."

	| ivOffset |
	(nil == anObject or: [ self size == 0 ])
		ifTrue: [ ^ self ].
	(ivOffset := self _ivOffsetFor: anObject) == nil
		ifTrue: [ ^ self recordNilOnPathForRoot: rootObject ].
	^ super addMappingsForObject: anObject root: rootObject logging: aBoolean
%

category: 'Adding'
method: GsOptionalPathTerm
removeMappingsFor: anObject root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the btree and dependency lists for anObject."

	| ivOffset |
	(nil == anObject or: [ self size == 0 ])
		ifTrue: [ ^ self ].
	(ivOffset := self _ivOffsetFor: anObject) == nil
		ifTrue: [ ^ self removeNilOnPathForRoot: rootObject ].
	^ super removeMappingsFor: anObject root: rootObject lastOne: aBoolean logging: doLogging
%

category: 'Private'
method: GsOptionalPathTerm
_findAllValuesForIdenticalRootObject: rootObject
	" if index directly on NSC elements or anObject is nil "

	| ivOffset |
	ivOffset := self _ivOffsetFor: rootObject.
	ivOffset
		ifNil: [ 
			"no values in index for rootObject"
			^ IdentityBag new ].
	^ super _findAllValuesForIdenticalRootObject: rootObject
%

category: 'Accessing'
method: GsOptionalPathTerm
_nextObjectFor: anObject atInstVar: anIvOffset
	"Returns the object at the instance variable that corresponds to the receiver
 path term."

	| ivOffset |
	ivOffset := self _ivOffsetFor: anObject.
	ivOffset ifNil: [ ^ nil ].
	^ super _nextObjectFor: anObject atInstVar: anIvOffset
%

! Class implementation for 'Upgrade3Init'

!		Class methods for 'Upgrade3Init'

category: 'Image Upgrade'
classmethod: Upgrade3Init
_disallowSubclasses
| list blk |
	blk := [:cls | "_unsafeDisallowSubclasses"
          cls _unsafeAt: 2 "offset of format"
             put: (cls format bitOr: 32 "subclasses disallowed bit") .
          cls _refreshClassCache: false
       ].
  list := { Behavior . Class . ObsoleteMetaclass . Repository . UserProfileSet .
     AbstractUserProfileSet .
     CompiledMethod . Float . DecimalFloat . SmallFloat . SmallDouble .
     Symbol . DoubleByteSymbol .
     UnimplementedFloat1 . UnimplementedFloat2 .
     MethodContext . Block . SelectionBlock .
     GsObjectSecurityPolicy . SymbolList . System . UndefinedObject . UserProfile . Boolean .
     Character . SmallInteger . Integer . LargeInteger .
     JISCharacter . StackSegment .
     StackBuffer . Activation . Process . VariableContext . BlockClosure .

     ExecBlock . ExecutableBlock . SimpleBlock . ComplexBlock . ComplexVCBlock . 
     ExecBlock0 . ExecBlock1 . ExecBlock2 . ExecBlock3 . ExecBlock4 . ExecBlock5 . ExecBlockN .
     GsMethod . GsNMethod . GsNativeCode .
     GsProcess . GsMethodDictionary . GsStackBuffer .

     SelectBlock . BasicSortNode .
     RcIndexDictionary . NscBuilder .

     "PathTerm . ConstrainedPathTerm . SetValuedPathTerm"  "fix bug 11484"
     }.
  list do: [ :aClass | blk value: aClass ].

  list do: [ :aClass |
     aClass subclassesDisallowed ifFalse:[ ^ 'Error on ' , aClass name ].
     ] .
%

category: 'Image Upgrade'
classmethod: Upgrade3Init
_setByteSwizzles
" Set the NbyteWords swizzle option in some byte format classes, so it
  shows up in the result of Class>>definition.  ominit.c synthesizes the
  in-memory swizzle info for the classes if needed when class is faulted in.
  Part of fix 47516."
| blk |
GsFile gciLogServer:'_setByteSwizzles'.
blk := [:cls :aSym | | fmt newFmt |
   fmt := cls format .
   newFmt := cls _addByteSwizzle: aSym toFormat: fmt newClassName: cls name signed: false .
   newFmt = fmt ifTrue:[
     GsFile gciLogServer: '  ',cls name, ' no change'.
   ] ifFalse:[
     cls _unsafeAt: 2 put: newFmt .
     GsFile gciLogServer: '  ',cls name, ' old format ', fmt asString, ' new format ', newFmt asString
   ].
].
{ DoubleByteString .
  DoubleByteSymbol .
  Unicode16  .
  Utf16
} do:[:aCls | blk value: aCls value: #'2byteWords' ].

{ LargeInteger  .
  QuadByteString .
  QuadByteSymbol .
  Unicode32 .
  SmallFloat .
  BitSet .
} do:[:aCls | blk value: aCls value: #'4byteWords' ].

{  Float
} do:[ :aCls | blk value: aCls value: #'8byteWords' ].
%

